/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.100 Revision 1.126
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.100 2011/11/19 20:31:12 pesa Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.126 2012/04/25 17:43:50 grobian Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Qt herd <qt@gentoo.org> 7# Qt herd <qt@gentoo.org>
8# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass contains various functions that are used when building Qt4. 10# This eclass contains various functions that are used when building Qt4.
11 11
12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
12inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
13 28
14MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
15MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
16 31
17HOMEPAGE="http://qt.nokia.com/" 32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH="${PV%.9999}"
37 ;;
38 release)
18SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 39 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
19LICENSE="|| ( LGPL-2.1 GPL-3 )" 40 ;;
41esac
20 42
21IUSE="aqua debug pch" 43IUSE="aqua debug pch"
22
23[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && 44if [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]]; then
24[[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] &&
25 IUSE+=" +exceptions" 45 IUSE+=" +exceptions"
26 46fi
27if version_is_at_least 4.7.99999999; then 47if version_is_at_least 4.8; then
28 IUSE+=" c++0x qpa" 48 IUSE+=" c++0x qpa"
49fi
50
51DEPEND="dev-util/pkgconfig"
52if [[ ${QT4_BUILD_TYPE} == live ]]; then
53 DEPEND+=" dev-lang/perl"
29fi 54fi
30 55
31RDEPEND=" 56RDEPEND="
32 !<x11-libs/qt-assistant-${PV} 57 !<x11-libs/qt-assistant-${PV}
33 !>x11-libs/qt-assistant-${PV}-r9999 58 !>x11-libs/qt-assistant-${PV}-r9999
59 !<x11-libs/qt-bearer-${PV}
60 !>x11-libs/qt-bearer-${PV}-r9999
34 !<x11-libs/qt-core-${PV} 61 !<x11-libs/qt-core-${PV}
35 !>x11-libs/qt-core-${PV}-r9999 62 !>x11-libs/qt-core-${PV}-r9999
36 !<x11-libs/qt-dbus-${PV} 63 !<x11-libs/qt-dbus-${PV}
37 !>x11-libs/qt-dbus-${PV}-r9999 64 !>x11-libs/qt-dbus-${PV}-r9999
38 !<x11-libs/qt-declarative-${PV} 65 !<x11-libs/qt-declarative-${PV}
43 !>x11-libs/qt-gui-${PV}-r9999 70 !>x11-libs/qt-gui-${PV}-r9999
44 !<x11-libs/qt-multimedia-${PV} 71 !<x11-libs/qt-multimedia-${PV}
45 !>x11-libs/qt-multimedia-${PV}-r9999 72 !>x11-libs/qt-multimedia-${PV}-r9999
46 !<x11-libs/qt-opengl-${PV} 73 !<x11-libs/qt-opengl-${PV}
47 !>x11-libs/qt-opengl-${PV}-r9999 74 !>x11-libs/qt-opengl-${PV}-r9999
75 !<x11-libs/qt-openvg-${PV}
76 !>x11-libs/qt-openvg-${PV}-r9999
48 !<x11-libs/qt-phonon-${PV} 77 !<x11-libs/qt-phonon-${PV}
49 !>x11-libs/qt-phonon-${PV}-r9999 78 !>x11-libs/qt-phonon-${PV}-r9999
50 !<x11-libs/qt-qt3support-${PV} 79 !<x11-libs/qt-qt3support-${PV}
51 !>x11-libs/qt-qt3support-${PV}-r9999 80 !>x11-libs/qt-qt3support-${PV}-r9999
52 !<x11-libs/qt-script-${PV} 81 !<x11-libs/qt-script-${PV}
65 94
66S=${WORKDIR}/${MY_P} 95S=${WORKDIR}/${MY_P}
67 96
68# @FUNCTION: qt4-build_pkg_setup 97# @FUNCTION: qt4-build_pkg_setup
69# @DESCRIPTION: 98# @DESCRIPTION:
70# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 99# Sets up PATH and LD_LIBRARY_PATH.
71qt4-build_pkg_setup() { 100qt4-build_pkg_setup() {
72 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 101 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
73 102
74 # Protect users by not allowing downgrades between releases 103 # Protect users by not allowing downgrades between releases
75 # Downgrading revisions within the same release should be allowed 104 # Downgrading revisions within the same release should be allowed
76 if has_version '>'${CATEGORY}/${P}-r9999; then 105 if has_version '>'${CATEGORY}/${P}-r9999; then
77 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 106 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
107 eerror
78 eerror "Sanity check to keep you from breaking your system:" 108 eerror "Sanity check to keep you from breaking your system:"
79 eerror " Downgrading Qt is completely unsupported and will break your system!" 109 eerror " Downgrading Qt is completely unsupported and will break your system!"
110 eerror
80 die "aborting to save your system" 111 die "aborting to save your system"
81 else 112 else
82 ewarn "Downgrading Qt is completely unsupported and will break your system!" 113 ewarn "Downgrading Qt is completely unsupported and will break your system!"
83 fi 114 fi
84 fi 115 fi
85 116
86 if [[ ${PN} == "qt-webkit" ]]; then 117 if [[ ${PN} == qt-webkit ]]; then
87 eshopts_push -s extglob 118 eshopts_push -s extglob
88 if is-flagq '-g?(gdb)?([1-9])'; then 119 if is-flagq '-g?(gdb)?([1-9])'; then
89 echo 120 echo
90 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)." 121 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
91 ewarn "You may experience really long compilation times and/or increased memory usage." 122 ewarn "You may experience really long compilation times and/or increased memory usage."
92 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug." 123 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
93 ewarn "For more info check out bug #307861" 124 ewarn "For more info check out bug #307861"
94 echo 125 echo
95 fi 126 fi
96 eshopts_pop 127 eshopts_pop
97 fi 128 fi
107 [[ ${CHOST} == *-apple-darwin* ]] && \ 138 [[ ${CHOST} == *-apple-darwin* ]] && \
108 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 139 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
109 ${QT4_EXTRACT_DIRECTORIES}" 140 ${QT4_EXTRACT_DIRECTORIES}"
110 fi 141 fi
111 142
112 # Make sure ebuilds use the required EAPI
113 if [[ ${EAPI} != [23] ]]; then
114 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
115 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
116 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
117 die "qt4-build eclass requires EAPI=2 or EAPI=3"
118 fi
119
120 if ! version_is_at_least 4.1 $(gcc-version); then 143 if ! version_is_at_least 4.1 $(gcc-version); then
121 ewarn "Using a GCC version lower than 4.1 is not supported!" 144 ewarn "Using a GCC version lower than 4.1 is not supported."
122 fi 145 fi
123} 146}
124 147
125# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 148# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
126# @DESCRIPTION: 149# @DESCRIPTION:
127# Arguments for build_target_directories. Takes the directories, in which the 150# Arguments for build_target_directories. Takes the directories in which the
128# code should be compiled. This is a space-separated list 151# code should be compiled. This is a space-separated list.
129 152
130# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 153# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
131# @DESCRIPTION: 154# @DESCRIPTION:
132# Space separated list including the directories that will be extracted from Qt 155# Space-separated list including the directories that will be extracted from
133# tarball 156# Qt tarball.
134 157
135# @FUNCTION: qt4-build_src_unpack 158# @FUNCTION: qt4-build_src_unpack
136# @DESCRIPTION: 159# @DESCRIPTION:
137# Unpacks the sources 160# Unpacks the sources.
138qt4-build_src_unpack() { 161qt4-build_src_unpack() {
139 setqtenv 162 setqtenv
140 local unpack_p="${MY_P}" 163
141 case "${PV}" in 164 case ${QT4_BUILD_TYPE} in
142 4.8.0_*) 165 live)
143 unpack_p="qt-everywhere-opensource-src-${PV/_*}" 166 git-2_src_unpack
144 ;; 167 ;;
168 release)
169 local tarball="${MY_P}.tar.gz" target= targets=
170 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
171 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
172 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
173 do
174 targets+="${MY_P}/${target} "
175 done
176
177 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
178 tar -xzf "${DISTDIR}/${tarball}" ${targets}
179 eend $? || die "failed to unpack"
180 ;;
145 esac 181 esac
146 local target targets=
147 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
148 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \
149 ${QT4_EXTRACT_DIRECTORIES}; do
150 targets+=" ${unpack_p}/${target}"
151 done
152
153 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets}
154 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die
155 case "${PV}" in
156 4.8.0_*)
157 mv ${WORKDIR}/qt-everywhere-opensource-src-${PV/_*} \
158 ${WORKDIR}/qt-everywhere-opensource-src-${MY_PV}
159 ;;
160 esac
161} 182}
162 183
163# @ECLASS-VARIABLE: PATCHES 184# @ECLASS-VARIABLE: PATCHES
185# @DEFAULT_UNSET
164# @DESCRIPTION: 186# @DESCRIPTION:
165# In case you have patches to apply, specify them in PATCHES variable. Make sure 187# PATCHES array variable containing all various patches to be applied.
166# to specify the full path. This variable is necessary for src_prepare phase. 188# This variable is expected to be defined in global scope of ebuild.
167# example: 189# Make sure to specify the full path. This variable is utilised in
168# PATCHES="${FILESDIR}"/mypatch.patch 190# src_unpack/src_prepare phase, based on EAPI.
169# ${FILESDIR}"/mypatch2.patch"
170# 191#
192# @CODE
193# PATCHES=( "${FILESDIR}/mypatch.patch"
194# "${FILESDIR}/patches_folder/" )
195# @CODE
171 196
172# @FUNCTION: qt4-build_src_prepare 197# @FUNCTION: qt4-build_src_prepare
173# @DESCRIPTION: 198# @DESCRIPTION:
174# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 199# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
175# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 200# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
176qt4-build_src_prepare() { 201qt4-build_src_prepare() {
177 setqtenv 202 setqtenv
178 cd "${S}"
179 203
180 # fix qt 4.7 regression that skips -fvisibility=hidden 204 if [[ ${QT4_BUILD_TYPE} == live ]]; then
181 if version_is_at_least "4.7.0_beta1"; then 205 QTDIR="." ./bin/syncqt || die "syncqt failed"
182 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
183 -i config.tests/unix/fvisibility.test ||
184 die "visibility fixing sed failed"
185 fi 206 fi
186 207
187 if version_is_at_least "4.7"; then 208 if version_is_at_least 4.7; then
188 # fix libX11 dependency on non X packages 209 # fix libX11 dependency on non X packages
189 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 210 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
190 has ${PN} ${nolibx11_pkgs} && qt_nolibx11 211 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
191 212
192 qt_assistant_cleanup 213 qt_assistant_cleanup
196 # provide a proper macx-g++-64 217 # provide a proper macx-g++-64
197 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 218 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
198 219
199 sed -e '/^CONFIG/s:app_bundle::' \ 220 sed -e '/^CONFIG/s:app_bundle::' \
200 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 221 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
201 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 222 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
202 fi 223 fi
203 224
204 if [[ ${PN} != qt-core ]]; then 225 if [[ ${PN} != qt-core ]]; then
205 skip_qmake_build 226 skip_qmake_build
206 skip_project_generation 227 skip_project_generation
207 symlink_binaries_to_buildtree 228 symlink_binaries_to_buildtree
208 fi 229 fi
209 230
210 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 231 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
211 # qmake bus errors with -O2 but -O3 works 232 # qmake bus errors with -O2 or -O3 but -O1 works
233 # Bug 373061
212 replace-flags -O2 -O3 234 replace-flags -O[23] -O1
213 fi 235 fi
214 236
215 # Bug 178652 237 # Bug 178652
216 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 238 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
217 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 239 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
218 append-flags -fno-gcse 240 append-flags -fno-gcse
219 fi 241 fi
220 242
221 if use_if_iuse c++0x; then 243 if use_if_iuse c++0x; then
244 echo
222 ewarn "You are about to build Qt4 using the C++11 standard. Even though" 245 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
223 ewarn "this is an official standard, some of the reverse dependencies" 246 ewarn "this is an official standard, some of the reverse dependencies"
224 ewarn "may fail to compile or link againt the Qt4 libraries. Before" 247 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
225 ewarn "reporting a bug, make sure your bug is reproducible with c++0x" 248 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
226 ewarn "disabled." 249 ewarn "disabled."
250 echo
227 append-flags -std=c++0x 251 append-flags -std=c++0x
228 fi 252 fi
229 253
230 # Unsupported old gcc versions - hardened needs this :( 254 # Unsupported old gcc versions - hardened needs this :(
231 if [[ $(gcc-major-version) -lt 4 ]] ; then 255 if [[ $(gcc-major-version) -lt 4 ]]; then
232 ewarn "Appending -fno-stack-protector to CXXFLAGS" 256 ewarn "Appending -fno-stack-protector to CXXFLAGS"
233 append-cxxflags -fno-stack-protector 257 append-cxxflags -fno-stack-protector
234 # Bug 253127 258 # Bug 253127
235 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 259 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
236 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 260 -i mkspecs/common/g++.conf || die
237 fi 261 fi
238 262
239 # Bug 261632 263 # Bug 261632
240 if use ppc64; then 264 if use ppc64; then
241 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 265 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
242 append-flags -mminimal-toc 266 append-flags -mminimal-toc
243 fi 267 fi
244 268
245 # Bug 282984 && Bug 295530 269 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
246 sed -e "s:\(^SYSTEM_VARIABLES\):CC=\"$(tc-getCC)\"\nCXX=\"$(tc-getCXX)\"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 270 sed -e "/^SYSTEM_VARIABLES=/i \
247 -i configure || die "sed qmake compilers failed" 271 CC='$(tc-getCC)'\n\
272 CXX='$(tc-getCXX)'\n\
273 CFLAGS='${CFLAGS}'\n\
274 CXXFLAGS='${CXXFLAGS}'\n\
275 LDFLAGS='${LDFLAGS}'\n" \
276 -i configure \
277 || die "sed SYSTEM_VARIABLES failed"
248 278
249 # Bug 321335 279 # Respect CC, CXX, LINK and *FLAGS in config.tests
250 if version_is_at_least 4.6; then 280 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
251 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 281 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
252 xargs -0 \ 282 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
253 sed -e "s:\(\$MAKE\):\1 CC=\"$(tc-getCC)\" CXX=\"$(tc-getCXX)\" LD=\"$(tc-getCXX)\" LINK=\"$(tc-getCXX)\":g" \ 283 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
254 -i || die "sed test compilers failed" 284 || die "sed config.tests failed"
255 fi 285
286 # Strip predefined CFLAGS from mkspecs (bug 312689)
287 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
256 288
257 # Bug 172219 289 # Bug 172219
258 sed -e "s:X11R6/::" \ 290 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
259 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
260 291
261 if [[ ${CHOST} == *-darwin* ]]; then 292 if [[ ${CHOST} == *-darwin* ]]; then
262 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 293 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
263 # crippled (by design) :/ 294 # crippled (by design) :/
295 local mac_gpp_conf=
296 if [[ -f mkspecs/common/mac-g++.conf ]]; then
297 # qt < 4.8 has mac-g++.conf
298 mac_gpp_conf="mkspecs/common/mac-g++.conf"
299 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
300 # qt >= 4.8 has g++-macx.conf
301 mac_gpp_conf="mkspecs/common/g++-macx.conf"
302 else
303 die "no known conf file for mac found"
304 fi
305 sed \
264 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 306 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
265 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 307 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
266 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 308 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
267 -e "s:-arch\s\w*::g" \ 309 -e "s:-arch\s\w*::g" \
268 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 310 -i ${mac_gpp_conf} \
311 || die "sed ${mac_gpp_conf} failed"
269 312
270 # Fix configure's -arch settings that appear in qmake/Makefile and also 313 # Fix configure's -arch settings that appear in qmake/Makefile and also
271 # fix arch handling (automagically duplicates our -arch arg and breaks 314 # fix arch handling (automagically duplicates our -arch arg and breaks
272 # pch). Additionally disable Xarch support. 315 # pch). Additionally disable Xarch support.
316 local mac_gcc_confs="${mac_gpp_conf}"
317 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
318 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
319 fi
273 sed \ 320 sed \
274 -e "s:-arch i386::" \ 321 -e "s:-arch i386::" \
275 -e "s:-arch ppc::" \ 322 -e "s:-arch ppc::" \
276 -e "s:-arch x86_64::" \ 323 -e "s:-arch x86_64::" \
277 -e "s:-arch ppc64::" \ 324 -e "s:-arch ppc64::" \
278 -e "s:-arch \$i::" \ 325 -e "s:-arch \$i::" \
279 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 326 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
280 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 327 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
281 -e "s:-Xarch_x86_64::g" \ 328 -e "s:-Xarch_x86_64::g" \
282 -e "s:-Xarch_ppc64::g" \ 329 -e "s:-Xarch_ppc64::g" \
283 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 330 -i configure ${mac_gcc_confs} \
331 || die "sed -arch/-Xarch failed"
284 332
285 # On Snow Leopard don't fall back to 10.5 deployment target. 333 # On Snow Leopard don't fall back to 10.5 deployment target.
286 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 334 if [[ ${CHOST} == *-apple-darwin10 ]]; then
287 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 335 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
288 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 336 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
289 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 337 -i configure ${mac_gpp_conf} \
338 || die "sed deployment target failed"
290 fi 339 fi
291 fi 340 fi
292 341
293 # this one is needed for all systems with a separate -liconv, apart from 342 # this one is needed for all systems with a separate -liconv, apart from
294 # Darwin, for which the sources already cater for -liconv 343 # Darwin, for which the sources already cater for -liconv
295 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 344 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
296 sed \ 345 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
297 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
298 -i config.tests/unix/iconv/iconv.pro \ 346 -i config.tests/unix/iconv/iconv.pro \
299 || die "sed on iconv.pro failed" 347 || die "sed iconv.pro failed"
300 fi 348 fi
301 349
302 # we need some patches for Solaris 350 # we need some patches for Solaris
303 sed -i \
304 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 351 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
305 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 352 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
306 # use GCC over SunStudio 353 # use GCC over SunStudio
307 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 354 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
308 # don't flirt with non-Prefix stuff, we're quite possessive 355 # do not flirt with non-Prefix stuff, we're quite possessive
309 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 356 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
310 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 357 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
311 # strip predefined CFLAGS from qmake ( bug #312689 )
312 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
313 358
314 base_src_prepare 359 base_src_prepare
315} 360}
316 361
317# @FUNCTION: qt4-build_src_configure 362# @FUNCTION: qt4-build_src_configure
318# @DESCRIPTION: 363# @DESCRIPTION:
319# Default configure phase 364# Default configure phase
320qt4-build_src_configure() { 365qt4-build_src_configure() {
321 setqtenv 366 setqtenv
322 myconf="$(standard_configure_options) ${myconf}" 367
368 local conf="
369 -prefix ${QTPREFIXDIR}
370 -bindir ${QTBINDIR}
371 -libdir ${QTLIBDIR}
372 -docdir ${QTDOCDIR}
373 -headerdir ${QTHEADERDIR}
374 -plugindir ${QTPLUGINDIR}
375 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
376 -datadir ${QTDATADIR}
377 -translationdir ${QTTRANSDIR}
378 -sysconfdir ${QTSYSCONFDIR}
379 -examplesdir ${QTEXAMPLESDIR}
380 -demosdir ${QTDEMOSDIR}
381 -opensource -confirm-license
382 -shared -fast -largefile -stl -verbose
383 -nomake examples -nomake demos"
384
385 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
386 # $(tc-arch). Therefore we convert it to supported values.
387 case "$(tc-arch)" in
388 amd64|x64-*) conf+=" -arch x86_64" ;;
389 ppc-macos) conf+=" -arch ppc" ;;
390 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
391 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
392 x86-macos) conf+=" -arch x86" ;;
393 x86|x86-*) conf+=" -arch i386" ;;
394 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
395 hppa|sh) conf+=" -arch generic" ;;
396 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
397 esac
398
399 conf+=" -platform $(qt_mkspecs_dir)"
400
401 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
402
403 # debug/release
404 if use debug; then
405 conf+=" -debug"
406 else
407 conf+=" -release"
408 fi
409 conf+=" -no-separate-debug-info"
410
411 # exceptions USE flag
412 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
413
414 # disable RPATH on Qt >= 4.8 (bug 380415)
415 version_is_at_least 4.8 && conf+=" -no-rpath"
416
417 # precompiled headers don't work on hardened, where the flag is masked
418 conf+=" $(qt_use pch)"
419
420 # -reduce-relocations
421 # This flag seems to introduce major breakage to applications,
422 # mostly to be seen as a core dump with the message "QPixmap: Must
423 # construct a QApplication before a QPaintDevice" on Solaris.
424 # -- Daniel Vergien
425 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
323 426
324 # this one is needed for all systems with a separate -liconv, apart from 427 # this one is needed for all systems with a separate -liconv, apart from
325 # Darwin, for which the sources already cater for -liconv 428 # Darwin, for which the sources already cater for -liconv
326 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 429 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
327 myconf+=" -liconv" 430 conf+=" -liconv"
431 fi
328 432
329 if use_if_iuse glib; then 433 if use_if_iuse glib; then
330 # use -I, -L and -l from configure
331 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 434 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
332 # avoid the -pthread argument 435 # avoid the -pthread argument
333 myconf+=" ${glibflags//-pthread}" 436 conf+=" ${glibflags//-pthread}"
334 unset glibflags 437 unset glibflags
335 fi 438 fi
336 439
337 if use_if_iuse qpa; then 440 if use_if_iuse qpa; then
338 ewarn 441 echo
339 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely" 442 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
340 ewarn "known as Qt Lighthouse. If you are not sure what that is, then" 443 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
341 ewarn "disable it before reporting any bugs related to this useflag." 444 ewarn "disable it before reporting any bugs related to this useflag."
342 ewarn 445 echo
343 myconf+=" -qpa" 446 conf+=" -qpa"
344 fi 447 fi
345 448
346 if use aqua ; then 449 if use aqua; then
347 # On (snow) leopard use the new (frameworked) cocoa code. 450 # On (snow) leopard use the new (frameworked) cocoa code.
348 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 451 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
349 myconf+=" -cocoa -framework" 452 conf+=" -cocoa -framework"
453 # We need the source's headers, not the installed ones.
454 conf+=" -I${S}/include"
455 # Add hint for the framework location.
456 conf+=" -F${QTLIBDIR}"
350 457
351 # We are crazy and build cocoa + qt3support :-) 458 # We are crazy and build cocoa + qt3support :-)
352 if use qt3support; then 459 if use qt3support; then
353 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 460 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
354 -i configure 461 -i configure || die
355 fi 462 fi
356 463 else
357 # We need the source's headers, not the installed ones. 464 conf+=" -no-framework"
358 myconf+=" -I${S}/include"
359
360 # Add hint for the framework location.
361 myconf+=" -F${QTLIBDIR}"
362 fi 465 fi
363 else 466 else
364 # freetype2 include dir is non-standard, thus include it on configure 467 # freetype2 include dir is non-standard, thus pass it to configure
365 # use -I from configure
366 myconf+=" $(pkg-config --cflags freetype2)" 468 conf+=" $(pkg-config --cflags-only-I freetype2)"
367 fi 469 fi
368 470
369 # Disable SSE4.x, since auto-detection is currently broken 471 conf+=" ${myconf}"
370 # Upstream bug http://bugreports.qt.nokia.com/browse/QTBUG-13623 472 myconf=
371 [[ ${PV} == "4.7.1" ]] && myconf+=" -no-sse4.1 -no-sse4.2"
372 473
373 echo ./configure ${myconf} 474 echo ./configure ${conf}
374 ./configure ${myconf} || die "./configure failed" 475 ./configure ${conf} || die "./configure failed"
375 myconf=""
376 476
377 prepare_directories ${QT4_TARGET_DIRECTORIES} 477 prepare_directories ${QT4_TARGET_DIRECTORIES}
378} 478}
379 479
380# @FUNCTION: qt4-build_src_compile 480# @FUNCTION: qt4-build_src_compile
388 488
389# @FUNCTION: qt4-build_src_test 489# @FUNCTION: qt4-build_src_test
390# @DESCRIPTION: 490# @DESCRIPTION:
391# Runs tests only in target directories. 491# Runs tests only in target directories.
392qt4-build_src_test() { 492qt4-build_src_test() {
493 # QtMultimedia does not have any test suite (bug #332299)
494 [[ ${PN} == qt-multimedia ]] && return
495
393 for dir in ${QT4_TARGET_DIRECTORIES}; do 496 for dir in ${QT4_TARGET_DIRECTORIES}; do
394 emake -j1 check -C ${dir} 497 emake -j1 check -C ${dir}
395 done 498 done
396} 499}
397 500
398# @FUNCTION: fix_includes 501# @FUNCTION: fix_includes
399# @DESCRIPTION: 502# @DESCRIPTION:
400# For MacOSX we need to add some symlinks when frameworks are 503# For MacOS X we need to add some symlinks when frameworks are
401# being used, to avoid complications with some more or less stupid packages. 504# being used, to avoid complications with some more or less stupid packages.
402fix_includes() { 505fix_includes() {
403 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 506 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
507 local frw dest f h rdir
404 # Some packages tend to include <Qt/...> 508 # Some packages tend to include <Qt/...>
405 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 509 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
406 510
407 # Fake normal headers when frameworks are installed... eases life later on 511 # Fake normal headers when frameworks are installed... eases life later
408 local dest f 512 # on, make sure we use relative links though, as some ebuilds assume
513 # these dirs exist in src_install to add additional files
514 f=${QTHEADERDIR}
515 h=${QTLIBDIR}
516 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
517 f=${f#*/}
518 h=${h#*/}
519 done
520 rdir=${h}
521 f="../"
522 while [[ ${h} == */* ]] ; do
523 f="${f}../"
524 h=${h#*/}
525 done
526 rdir="${f}${rdir}"
527
409 for frw in "${D}${QTLIBDIR}"/*.framework; do 528 for frw in "${D}${QTLIBDIR}"/*.framework; do
410 [[ -e "${frw}"/Headers ]] || continue 529 [[ -e "${frw}"/Headers ]] || continue
411 f=$(basename ${frw}) 530 f=$(basename ${frw})
412 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 531 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
413 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 532 dosym "${rdir}"/${f}/Headers "${dest}"
414 533
415 # Link normal headers as well. 534 # Link normal headers as well.
416 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 535 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
417 h=$(basename ${hdr}) 536 h=$(basename ${hdr})
418 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 537 dosym "../${rdir}"/${f}/Headers/${h} \
538 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
419 done 539 done
420 done 540 done
421 fi 541 fi
422} 542}
423 543
432 install_qconfigs 552 install_qconfigs
433 fix_library_files 553 fix_library_files
434 fix_includes 554 fix_includes
435 555
436 # remove .la files since we are building only shared Qt libraries 556 # remove .la files since we are building only shared Qt libraries
437 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm 557 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
438} 558}
439 559
440# @FUNCTION: setqtenv 560# @FUNCTION: setqtenv
561# @INTERNAL
441setqtenv() { 562setqtenv() {
442 # Set up installation directories 563 # Set up installation directories
443 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
444 QTPREFIXDIR=${EPREFIX}/usr 564 QTPREFIXDIR=${EPREFIX}/usr
445 QTBINDIR=${EPREFIX}/usr/bin 565 QTBINDIR=${EPREFIX}/usr/bin
446 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 566 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
447 QMAKE_LIBDIR_QT=${QTLIBDIR}
448 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 567 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
449 QTDATADIR=${EPREFIX}/usr/share/qt4
450 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 568 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
451 QTHEADERDIR=${EPREFIX}/usr/include/qt4 569 QTHEADERDIR=${EPREFIX}/usr/include/qt4
452 QTPLUGINDIR=${QTLIBDIR}/plugins 570 QTPLUGINDIR=${QTLIBDIR}/plugins
571 QTIMPORTDIR=${QTLIBDIR}/imports
572 QTDATADIR=${EPREFIX}/usr/share/qt4
573 QTTRANSDIR=${QTDATADIR}/translations
453 QTSYSCONFDIR=${EPREFIX}/etc/qt4 574 QTSYSCONFDIR=${EPREFIX}/etc/qt4
454 QTTRANSDIR=${QTDATADIR}/translations
455 QTEXAMPLESDIR=${QTDATADIR}/examples 575 QTEXAMPLESDIR=${QTDATADIR}/examples
456 QTDEMOSDIR=${QTDATADIR}/demos 576 QTDEMOSDIR=${QTDATADIR}/demos
577 QMAKE_LIBDIR_QT=${QTLIBDIR}
457 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 578 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
579
458 PLATFORM=$(qt_mkspecs_dir) 580 PLATFORM=$(qt_mkspecs_dir)
459 581
460 unset QMAKESPEC 582 unset QMAKESPEC
461}
462
463# @FUNCTION: standard_configure_options
464# @DESCRIPTION:
465# Sets up some standard configure options, like libdir (if necessary), whether
466# debug info is wanted or not.
467standard_configure_options() {
468 local myconf=
469
470 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
471
472 # Disable visibility explicitly if gcc version isn't 4
473 if [[ $(gcc-major-version) -lt 4 ]]; then
474 myconf+=" -no-reduce-exports"
475 fi
476
477 # precompiled headers doesn't work on hardened, where the flag is masked.
478 myconf+=" $(qt_use pch)"
479
480 if use debug; then
481 myconf+=" -debug"
482 else
483 myconf+=" -release"
484 fi
485 myconf+=" -no-separate-debug-info"
486
487 use aqua && myconf+=" -no-framework"
488
489 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
490 # $(tc-arch). Therefore we convert it to supported values.
491 case "$(tc-arch)" in
492 amd64|x64-*) myconf+=" -arch x86_64" ;;
493 ppc-macos) myconf+=" -arch ppc" ;;
494 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
495 sparc|sparc-*) myconf+=" -arch sparc" ;;
496 x86-macos) myconf+=" -arch x86" ;;
497 x86|x86-*) myconf+=" -arch i386" ;;
498 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
499 hppa|sh) myconf+=" -arch generic" ;;
500 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
501 esac
502
503 # exceptions USE flag
504 local exceptions="-exceptions"
505 in_iuse exceptions && exceptions="$(qt_use exceptions)"
506
507 # note about -reduce-relocations:
508 # That flag seems to introduce major breakage to applications,
509 # mostly to be seen as a core dump with the message "QPixmap: Must
510 # construct a QApplication before a QPaintDevice" on Solaris
511 # -- Daniel Vergien
512 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
513
514 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
515 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
516 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
517 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
518 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
519 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
520 ${exceptions}
521 -nomake examples -nomake demos"
522
523 echo "${myconf}"
524} 583}
525 584
526# @FUNCTION: prepare_directories 585# @FUNCTION: prepare_directories
527# @USAGE: < directories > 586# @USAGE: < directories >
587# @INTERNAL
528# @DESCRIPTION: 588# @DESCRIPTION:
529# Generates makefiles for the directories set in $QT4_TARGET_DIRECTORIES 589# Generates Makefiles for the given list of directories.
530prepare_directories() { 590prepare_directories() {
531 for x in "$@"; do 591 for x in "$@"; do
532 pushd "${S}"/${x} >/dev/null 592 pushd "${S}"/${x} >/dev/null || die
533 einfo "Running qmake in: ${x}" 593 einfo "Running qmake in: ${x}"
534 # avoid running over the maximum argument number, bug #299810 594 # avoid running over the maximum argument number, bug #299810
535 { 595 {
536 echo "${S}"/mkspecs/common/*.conf 596 echo "${S}"/mkspecs/common/*.conf
537 find "${S}" -name '*.pr[io]' 597 find "${S}" -name '*.pr[io]'
538 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 598 } | xargs sed -i \
599 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
600 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
601 || die
539 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 602 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
540 popd >/dev/null 603 popd >/dev/null || die
541 done 604 done
542} 605}
543 606
544 607
545# @FUNCTION: build_directories 608# @FUNCTION: build_directories
546# @USAGE: < directories > 609# @USAGE: < directories >
610# @INTERNAL
547# @DESCRIPTION: 611# @DESCRIPTION:
548# Compiles the code in $QT4_TARGET_DIRECTORIES 612# Compiles the code in the given list of directories.
549build_directories() { 613build_directories() {
550 for x in "$@"; do 614 for x in "$@"; do
551 pushd "${S}"/${x} >/dev/null 615 pushd "${S}"/${x} >/dev/null || die
552 emake CC="$(tc-getCC)" \ 616 emake CC="$(tc-getCC)" \
553 CXX="$(tc-getCXX)" \ 617 CXX="$(tc-getCXX)" \
554 LINK="$(tc-getCXX)" || die "emake failed" 618 LINK="$(tc-getCXX)" || die "emake failed"
555 popd >/dev/null 619 popd >/dev/null || die
556 done 620 done
557} 621}
558 622
559# @FUNCTION: install_directories 623# @FUNCTION: install_directories
560# @USAGE: < directories > 624# @USAGE: < directories >
625# @INTERNAL
561# @DESCRIPTION: 626# @DESCRIPTION:
562# run emake install in the given directories, which are separated by spaces 627# Runs emake install in the given directories, which are separated by spaces.
563install_directories() { 628install_directories() {
564 for x in "$@"; do 629 for x in "$@"; do
565 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 630 pushd "${S}"/${x} >/dev/null || die
566 emake INSTALL_ROOT="${D}" install || die "emake install failed" 631 emake INSTALL_ROOT="${D}" install || die "emake install failed"
567 popd >/dev/null || die "Can't popd from ${S}/${x}" 632 popd >/dev/null || die
568 done 633 done
569} 634}
570 635
571# @ECLASS-VARIABLE: QCONFIG_ADD 636# @ECLASS-VARIABLE: QCONFIG_ADD
572# @DESCRIPTION: 637# @DESCRIPTION:
582# @DESCRIPTION: 647# @DESCRIPTION:
583# List variables that should be defined at the top of QtCore/qconfig.h 648# List variables that should be defined at the top of QtCore/qconfig.h
584: ${QCONFIG_DEFINE:=} 649: ${QCONFIG_DEFINE:=}
585 650
586# @FUNCTION: install_qconfigs 651# @FUNCTION: install_qconfigs
652# @INTERNAL
587# @DESCRIPTION: 653# @DESCRIPTION:
588# Install gentoo-specific mkspecs configurations 654# Install gentoo-specific mkspecs configurations.
589install_qconfigs() { 655install_qconfigs() {
590 local x 656 local x
591 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 657 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
592 for x in QCONFIG_ADD QCONFIG_REMOVE; do 658 for x in QCONFIG_ADD QCONFIG_REMOVE; do
593 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 659 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
604 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 670 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
605 fi 671 fi
606} 672}
607 673
608# @FUNCTION: generate_qconfigs 674# @FUNCTION: generate_qconfigs
675# @INTERNAL
609# @DESCRIPTION: 676# @DESCRIPTION:
610# Generates gentoo-specific configurations 677# Generates gentoo-specific qconfig.{h,pri}.
611generate_qconfigs() { 678generate_qconfigs() {
612 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 679 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
613 local x qconfig_add qconfig_remove qconfig_new 680 local x qconfig_add qconfig_remove qconfig_new
614 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 681 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
615 [[ -f ${x} ]] || continue 682 [[ -f ${x} ]] || continue
616 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 683 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
617 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 684 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
664 fi 731 fi
665} 732}
666 733
667# @FUNCTION: qt4-build_pkg_postrm 734# @FUNCTION: qt4-build_pkg_postrm
668# @DESCRIPTION: 735# @DESCRIPTION:
669# Generate configurations when the package is completely removed 736# Regenerate configuration when the package is completely removed.
670qt4-build_pkg_postrm() { 737qt4-build_pkg_postrm() {
671 generate_qconfigs 738 generate_qconfigs
672} 739}
673 740
674# @FUNCTION: qt4-build_pkg_postinst 741# @FUNCTION: qt4-build_pkg_postinst
675# @DESCRIPTION: 742# @DESCRIPTION:
676# Generate configuration, plus throws a message about possible 743# Regenerate configuration, plus throw a message about possible
677# breakages and proposed solutions. 744# breakages and proposed solutions.
678qt4-build_pkg_postinst() { 745qt4-build_pkg_postinst() {
679 generate_qconfigs 746 generate_qconfigs
680} 747}
681 748
682# @FUNCTION: skip_qmake_build 749# @FUNCTION: skip_qmake_build
750# @INTERNAL
683# @DESCRIPTION: 751# @DESCRIPTION:
684# Don't need to build qmake, as it's already installed from qt-core 752# Patches configure to skip qmake compilation, as it's already installed by qt-core.
685skip_qmake_build() { 753skip_qmake_build() {
686 # Don't need to build qmake, as it's already installed from qt-core
687 sed -i -e "s:if true:if false:g" "${S}"/configure || die "sed failed" 754 sed -i -e "s:if true:if false:g" "${S}"/configure || die
688} 755}
689 756
690# @FUNCTION: skip_project_generation 757# @FUNCTION: skip_project_generation
758# @INTERNAL
691# @DESCRIPTION: 759# @DESCRIPTION:
692# Exit the script early by throwing in an exit before all of the .pro files are scanned 760# Exit the script early by throwing in an exit before all of the .pro files are scanned.
693skip_project_generation() { 761skip_project_generation() {
694 # Exit the script early by throwing in an exit before all of the .pro files are scanned
695 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 762 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
696 -i "${S}"/configure || die "sed failed"
697} 763}
698 764
699# @FUNCTION: symlink_binaries_to_buildtree 765# @FUNCTION: symlink_binaries_to_buildtree
766# @INTERNAL
700# @DESCRIPTION: 767# @DESCRIPTION:
701# Symlink generated binaries to buildtree so they can be used during compilation 768# Symlinks generated binaries to buildtree, so they can be used during compilation time.
702# time
703symlink_binaries_to_buildtree() { 769symlink_binaries_to_buildtree() {
704 for bin in qmake moc uic rcc; do 770 for bin in qmake moc uic rcc; do
705 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed" 771 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
706 done 772 done
707} 773}
708 774
709# @FUNCTION: fix_library_files 775# @FUNCTION: fix_library_files
776# @INTERNAL
710# @DESCRIPTION: 777# @DESCRIPTION:
711# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 778# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
712# moves the *.pc-files into the pkgconfig directory 779# moves the *.pc files into the pkgconfig directory.
713fix_library_files() { 780fix_library_files() {
781 local libfile
714 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 782 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
715 if [[ -e ${libfile} ]]; then 783 if [[ -e ${libfile} ]]; then
716 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed" 784 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
717 fi 785 fi
718 done 786 done
719 787
720 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 788 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
721 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 789 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
722 if [[ -e ${libfile} ]]; then 790 if [[ -e ${libfile} ]]; then
723 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed failed" 791 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
724 792
725 # Move .pc files into the pkgconfig directory 793 # Move .pc files into the pkgconfig directory
726 dodir ${QTPCDIR#${EPREFIX}} 794 dodir ${QTPCDIR#${EPREFIX}}
727 mv ${libfile} "${D}"/${QTPCDIR}/ \ 795 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
728 || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
729 fi 796 fi
730 done 797 done
731 798
732 # Don't install an empty directory 799 # Don't install an empty directory
733 rmdir "${D}"/${QTLIBDIR}/pkgconfig 800 rmdir "${D}"/${QTLIBDIR}/pkgconfig
734} 801}
735 802
736# @FUNCTION: qt_use 803# @FUNCTION: qt_use
737# @USAGE: < flag > [ feature ] [ enableval ] 804# @USAGE: < flag > [ feature ] [ enableval ]
738# @DESCRIPTION: 805# @DESCRIPTION:
739# This will echo "${enableval}-${feature}" if <flag> is enabled, or 806# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
740# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 807# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
741# will be used for that. If [enableval] is not specified, it omits the 808# will be used for that. If [enableval] is not specified, it omits the
742# assignment-part 809# "-${enableval}" part.
743qt_use() { 810qt_use() {
744 local flag=$1 811 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
745 local feature=$1
746 local enableval=
747
748 [[ -n $2 ]] && feature=$2
749 [[ -n $3 ]] && enableval=-$3
750
751 if use ${flag}; then
752 echo "${enableval}-${feature}"
753 else
754 echo "-no-${feature}"
755 fi
756} 812}
757 813
758# @FUNCTION: qt_mkspecs_dir 814# @FUNCTION: qt_mkspecs_dir
759# @RETURN: the specs-directory w/o path 815# @RETURN: the specs-directory w/o path
760# @DESCRIPTION: 816# @DESCRIPTION:
761# Allows us to define which mkspecs dir we want to use. 817# Allows us to define which mkspecs dir we want to use.
762qt_mkspecs_dir() { 818qt_mkspecs_dir() {
763 # Allows us to define which mkspecs dir we want to use.
764 local spec 819 local spec=
765 820
766 case ${CHOST} in 821 case "${CHOST}" in
767 *-freebsd*|*-dragonfly*) 822 *-freebsd*|*-dragonfly*)
768 spec=freebsd ;; 823 spec=freebsd ;;
769 *-openbsd*) 824 *-openbsd*)
770 spec=openbsd ;; 825 spec=openbsd ;;
771 *-netbsd*) 826 *-netbsd*)
782 *-solaris*) 837 *-solaris*)
783 spec=solaris ;; 838 spec=solaris ;;
784 *-linux-*|*-linux) 839 *-linux-*|*-linux)
785 spec=linux ;; 840 spec=linux ;;
786 *) 841 *)
787 die "Unknown CHOST, no platform chosen" 842 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
788 esac 843 esac
789 844
790 CXX=$(tc-getCXX) 845 case "$(tc-getCXX)" in
791 if [[ ${CXX} == *g++* ]]; then 846 *g++*)
792 spec+=-g++ 847 spec+=-g++ ;;
793 elif [[ ${CXX} == *icpc* ]]; then 848 *icpc*)
794 spec+=-icc 849 spec+=-icc ;;
795 else 850 *)
796 die "Unknown compiler '${CXX}'" 851 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
797 fi 852 esac
798 if [[ -n ${LIBDIR/lib} ]]; then
799 spec+=-${LIBDIR/lib}
800 fi
801 853
802 # Add -64 for 64bit profiles 854 # Add -64 for 64bit profiles
803 if use x64-freebsd || 855 if use x64-freebsd ||
804 use amd64-linux || 856 use amd64-linux ||
805 use x64-macos || 857 use x64-macos ||
811 863
812 echo "${spec}" 864 echo "${spec}"
813} 865}
814 866
815# @FUNCTION: qt_assistant_cleanup 867# @FUNCTION: qt_assistant_cleanup
816# @RETURN: nothing 868# @INTERNAL
817# @DESCRIPTION: 869# @DESCRIPTION:
818# Tries to clean up tools.pro for qt-assistant ebuilds. 870# Tries to clean up tools.pro for qt-assistant ebuilds.
819# Meant to be called in src_prepare(). 871# Meant to be called in src_prepare().
820# Since Qt 4.7.4 this function is a no-op. 872# Since Qt 4.7.4 this function is a no-op.
821qt_assistant_cleanup() { 873qt_assistant_cleanup() {
822 # apply patching to qt-assistant ebuilds only 874 # apply patching to qt-assistant ebuilds only
823 [[ ${PN} != "qt-assistant" ]] && return 875 [[ ${PN} != qt-assistant ]] && return
824 876
825 # no longer needed for 4.7.4 and later 877 # no longer needed for 4.7.4 and later
826 version_is_at_least "4.7.4" && return 878 version_is_at_least 4.7.4 && return
827 879
828 # different versions (and branches...) may need different handling, 880 # different versions (and branches...) may need different handling,
829 # add a case if you need special handling 881 # add a case if you need special handling
830 case "${MY_PV_EXTRA}" in 882 case "${MY_PV_EXTRA}" in
831 *kde-qt*) 883 *kde-qt*)
841 ;; 893 ;;
842 esac 894 esac
843} 895}
844 896
845# @FUNCTION: qt_nolibx11 897# @FUNCTION: qt_nolibx11
846# @RETURN: nothing 898# @INTERNAL
847# @DESCRIPTION: 899# @DESCRIPTION:
848# Ignore X11 tests for packages that don't need X libraries installed 900# Ignore X11 tests for packages that don't need X libraries installed.
849qt_nolibx11() { 901qt_nolibx11() {
850 einfo "Removing X11 check to allow X-less compilation"
851 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure || 902 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
852 die "x11 check sed failed" 903 die "x11 check sed failed"
853} 904}
854 905
855EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 906EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.100  
changed lines
  Added in v.1.126

  ViewVC Help
Powered by ViewVC 1.1.20